//Ball Generator (Var Speed/Generation Amount) on May 3 - Jun 15\\
//Created by David Yee\\
#include <acknex.h>
#include <default.c>
var gen_random_loc = 0;
var ball_speed = 100;
var gen_loc_status = 0;
var gen_rand_status = 0;
var gen_random_ball = 0;
var gen_display = 0;
ENTITY* BALL;
BMAP* game_image = "game_menu_en.pcx";
char *MDL = "ball1.mdl";
function	cfnctns();
PANEL* game_menu_pan = //main pan
	{
		layer = 5;
		bmap = game_image; // main control
		button (60, 185, "Button_OFF.pcx", "Button_ON.pcx", "Button_ON.pcx", add_gen_random_loc, NULL, NULL);
		button (515, 185, "Button_OFF_B.pcx", "Button_ON_B.pcx", "Button_ON_B.pcx", add_gen_random_ball, NULL, NULL);
		button (670, 10, "exit_button.pcx", "exit_button.pcx", "exit_button.pcx", exit_helpscreen, NULL, NULL);
		hslider (250, 185, 182, "hslider01.pcx", 100, 1000, ball_speed);
		digits (325, 250, 4, *, 1, ball_speed);
		pos_x = 50;
		pos_y = 50;			
		flags = VISIBLE;	
	}
function game_menu_display_key()
	{
		if(game_menu_pan.flags == VISIBLE){reset(game_menu_pan,VISIBLE);}
		else{set(game_menu_pan,VISIBLE);}
		cfnctns();
	}
function add_gen_random_loc(){gen_random_loc ^= 1;}
function add_gen_random_ball(){gen_random_ball ^= 1;}
function vector_random()
	{
		ph_setgravity (vector(0, 0, -ball_speed)); //set the downwards gravity
		phent_settype (BALL, PH_RIGID, PH_SPHERE); //set the physics type/mode
		phent_setmass (BALL, 5, PH_SPHERE); //set the mass
		phent_setfriction (BALL, 40); //set the resistance
		phent_setdamping (BALL, 20, 20); //set the damping
		phent_setelasticity (BALL, 75, 30); //set the elasticity
	}
function ball_random()
	{
		if(gen_random_ball >= 1){*(MDL+4) = integer(random(3))+'1';}
	}
function ball_drop()
	{
		if (gen_random_loc >= 1)
		{
			ball_random();
			wait(2);
			BALL = ent_create (MDL, vector(random(256)-128, random(256)-128, random(256)-128), NULL); //generate ball
		}
		else
		{
			ball_random();
			wait (2);
			BALL = ent_create (MDL, vector(0, 0, 100), NULL); //generate ball
		}
		vector_random();
		cfnctns();
	}
function remove_all()
	{
		level_load ("Platform2.wmb");
		cfnctns();
	}
function exit_helpscreen()
	{
		reset(game_menu_pan,VISIBLE);
		cfnctns();
	}
function	cfnctns()
	{
		while(1)
		{
		on_r = ball_drop;
		on_del = remove_all;
		on_f1 = game_menu_display_key;
				{
					mouse_pos.x = mouse_cursor.x; // cursor movement
					mouse_pos.y = mouse_cursor.y; // movement on the xy axis	
				}
		wait(1);
		}
	}
function main()
	{
		video_screen = 2;
		video_mode = 7;
		level_load ("Platform2.wmb");
		screen_color.green = 128;
		mouse_mode = 1;
		mouse_map = NULL;
		cfnctns();
		}